/*
 * @Description: 测试车位分配模块通信情况
 * @Author: yct
 * @Date: 2020-07-08 15:51:46
 * @LastEditTime: 2020-07-08 17:38:21
 * @LastEditors: yct
 */ 
#include "../parkspace_allocation/parkspace_allocation_communicator.h"

int main()
{
    Parkspace_allocation_communicator *p_parkspace_allocator = Parkspace_allocation_communicator::get_instance_pointer();
    
    p_parkspace_allocator->communication_bind("tcp://127.0.0.1:7001");
    p_parkspace_allocator->communication_connect("tcp://127.0.0.1:7000");
    p_parkspace_allocator->communication_run();

    message::Parkspace_allocation_status_msg parkspace_status;
    for (size_t i = 1; i < 4; i++)
    {
        message::Parkspace_info* space = parkspace_status.add_parkspace_info();
        space->set_parkspace_id(i);
        space->set_x_coordinate(i*100);
        space->set_y_coordinate(i*200);
        space->set_z_coordinate(i*300);
        space->set_length(5500);
        space->set_width(2200);
        space->set_height(1750);
        space->set_parkspace_status(message::Parkspace_status::eParkspace_empty);
    }
    message::Base_info base_msg;
    message::Error_manager error;
    base_msg.set_msg_type(message::Message_type::eParkspace_allocation_response_msg);
    base_msg.set_timeout_ms(1000);
    base_msg.set_sender(message::Communicator::eParkspace_allocator);
    base_msg.set_receiver(message::Communicator::eMain);
    error.set_error_code(0);
    parkspace_status.mutable_base_info()->CopyFrom(base_msg);
    parkspace_status.mutable_error_manager()->CopyFrom(error);
    p_parkspace_allocator->update_parkspace_status(parkspace_status);

    int k=1;

    while(1) {
        message::Parkspace_info space;
        space.set_parkspace_id(3);
        space.set_x_coordinate(k*100);
        space.set_y_coordinate(k*200);
        space.set_z_coordinate(k*300);
        space.set_length(5500);
        space.set_width(2200);
        space.set_height(k*400);
        space.set_parkspace_status(message::Parkspace_status::eParkspace_occupied);
        p_parkspace_allocator->update_parkspace_status(3, space);
        usleep(1000*1000);
        k++;
    }

    return 0;
}